#!/usr/bin/perl -w
# 
# OS Reviews CMS: generate rating images
# 
# Copyright (C) 2006 Hendrik Weimer, OS Reviews
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.

use strict;
use Imager;

my ($i, $img, $color, $font, $file, $j);

my $outdir = 'rating';

my $white = Imager::Color->new(red => 255, blue => 255, green => 255);
my $black = Imager::Color->new(red => 0, blue => 0, green => 0);

for($i=0; $i<100; $i++)
{
    $img = Imager->new(xsize => 72, ysize => 72);

    $img->box(color => $white, xmin => 0, ymin => 0, xmax => 72, ymax => 72,
	      filled => 1);

    $j = int($i/100*255);

    $color = Imager::Color->new(red => $j, blue => 255-$j, green => 0);

    $j = int($i*360/100)-90;

    if($i < 50)
    {
	$img->arc(color => $color, x => 36, y => 36, r => 30, 
		  d1 => -90, d2 => $j);
    }
    else
    {
        $img->arc(color => $color, x => 36, y => 36, r => 30, 
		  d1 => -90, d2 => 90);
	$img->arc(color => $color, x => 36, y => 36, r => 30, 
		  d1 => 90, d2 => $j);
    }

    $img->circle(color => $white, x => 36, y => 36, r => 18);

    $img->write(file => 'temp.ppm') or die $img->errstr;

    `pnmsmooth temp.ppm > temp2.ppm`;
    unlink 'temp.ppm';

    $img->read(file => 'temp2.ppm');
    unlink 'temp2.ppm';

    $font = Imager::Font->new(file  => '/usr/share/fonts/truetype/freefont/FreeSansBold.ttf',
			      index => 0,
			      color => $black,
			      size  => 24,
			      aa    => 1);
    
    $font->align(string=>$i, x=>36, y=>36, 
                 halign=>'center', valign=>'center', 
                 image=>$img);

    $file = "$outdir/$i.png";
    $file = "$outdir/0$i.png" if $i < 10;

    $img->write(file => $file) or die $img->errstr;
}
